/*
 * Copyright (c) 2005, Your Corporation. All Rights Reserved.
 */

package classUtils.pathUtils;

import utils.SystemUtils;

import java.io.File;
import java.io.IOException;
import java.util.jar.JarFile;
import java.util.Enumeration;

import bookExamples.ch15Streams.Unzipper;

public class NativeLibDetect {
    private String libLocation = null;

    public NativeLibDetect(String libName) {
        libLocation = nativeLibFind(
                System.mapLibraryName(libName),
                SystemUtils.getLibraryPaths());
    }

    public static void printLibraryPaths() {
        print(SystemUtils.getLibraryPaths());
    }



    private static void print(String libraryPaths[]) {
        for (int i=0; i < libraryPaths.length; i++)
            System.out.println(libraryPaths[i]);
    }

    public static boolean isLibInPath(String libName) {
        NativeLibDetect nld = new NativeLibDetect(libName);
        return nld.getLibLocation() != null;
    }

    public static String getPathToLib(String libName) {
        NativeLibDetect nld = new NativeLibDetect(libName);
        return nld.getLibLocation();
    }

    public String nativeLibFind(String libName, String paths[]) {
        System.out.println("searching for:"+libName);
        System.out.println(SystemUtils.getLibraryPath());
        for (int i = 0; i < paths.length; i++) {
            File f = new File(paths[i],libName);
            if (f.exists()) return f.getAbsolutePath();
        }
        return null;
    }

    public static void main(String[] args) {
        try {
            System.out.println("lib in path?:"+NativeLibDetect.isLibInPath("rxtxSerial"));
            SystemUtils.appendJavaLibraryPath(new File("native.jar").getAbsolutePath());
            System.out.println("lib in path?:"+NativeLibDetect.isLibInPath("rxtxSerial"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getLibLocation() {
        return libLocation;
    }
}
